﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Core.Layers;
using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Events;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.Win.UltraWinChart;

namespace WindowsFormsApplication1
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			this.ultraChart1.ColorModel.ModelStyle = ColorModels.CustomSkin;
			this.ultraChart1.ColorModel.Skin.ApplyRowWise = false;
			this.ultraChart1.ColorModel.Skin.PEs.AddRange(new PaintElement[] {
				new PaintElement(Color.Red),
				new PaintElement(Color.Green),
				new PaintElement(Color.Blue),
				new PaintElement(Color.Yellow),
				new PaintElement(Color.Purple)});

			// just for clarity
			this.ultraChart1.Tooltips.FormatString = "<CUSTOM_TOOLTIP>";
			this.ultraChart1.LabelHash = new System.Collections.Hashtable();
			this.ultraChart1.LabelHash.Add("CUSTOM_TOOLTIP", new TooltipIRenderLabel());

			var rnd = new Random();
			var mfi = new DateTimeFormatInfo();

			for (int i = 0; i < 12; i++)
			{
				var row = dataSet1.Tables[0].NewRow();
				row.ItemArray = new object[] { rnd.Next(5, 30), rnd.Next(5, 30), rnd.Next(5, 30), rnd.Next(5, 25), rnd.Next(5, 20), mfi.GetMonthName(i + 1) };
				dataSet1.Tables[0].Rows.Add(row);
			}

			var lineText = new ChartTextAppearance();
			lineText.Column = -2;
			lineText.Row = -2;
			lineText.ItemFormatString = "<DATA_VALUE:#0>";
			lineText.Visible = true;
			ultraChart1.ColumnLineChart.Line.ChartText.Add(lineText);

			ultraChart1.DataSource = dataSet1.Tables[0];
		}

		private void ultraChart1_FillSceneGraph(object sender, FillSceneGraphEventArgs e)
		{
			if (e.SceneGraph.Count > 3)
			{
				var chart = sender as UltraChart;
				var g = chart.CreateGraphics();
				var textPrimitives = (from Primitive primitive in e.SceneGraph
									  where (primitive is Text) && (primitive.Path == null)
									  select primitive).ToArray();
				foreach (Primitive prim in textPrimitives)
				{
					var text = prim as Text;

					// Get the size of the text.
					var textSizeF = g.MeasureString(text.GetTextString(), chart.ColumnLineChart.Line.ChartText[0].ChartTextFont);

					// Position the rect so it's behind the text.
					var rect = new Rectangle(text.bounds.Location, new Size((int)textSizeF.Width, (int)textSizeF.Height));
					rect.Offset(((rect.Width / 2) * -1) - 1, ((rect.Height / 2) * -1) - 1);

					// Create the box.
					var box = new Box(rect);
					box.lineStyle.DrawStyle = LineDrawStyle.Solid;
					box.PE.Stroke = Color.Black;
					box.PE.Fill = Color.Cyan;
					box.Visible = true;

					// Ensure the box appears behind the text.
					e.SceneGraph.InsertBefore(box, text);
				}
			}
		}
	}
}
